variables:
  DOCKER_REGISTRY: 432806165674.dkr.ecr.eu-central-1.amazonaws.com
  AWS_DEFAULT_REGION: eu-central-1
  APP_NAME: conduit_front_end
  BUILD_CACHE: build_cache
  DOCKER_HOST: tcp://docker:2375
  BUILD_STAGE_IMAGE: "$DOCKER_REGISTRY/$BUILD_CACHE:latest"
  FINAL_IMAGE: "$DOCKER_REGISTRY/$APP_NAME:latest"


stages:          # List of stages for jobs, and their order of execution
  - build
  - trigger

publish-front-image-ecr::
  stage: build
  image: 
    name: registry.gitlab.com/m10200/docker-image-builder
    entrypoint: [""]
  services:
    - docker:dind
    - aws --version
    - docker --version
  script:
    - aws ecr get-login-password | docker login --username AWS --password-stdin $DOCKER_REGISTRY
    # BUILD STAGE
    - docker pull ${BUILD_STAGE_IMAGE} || true
    - docker build --target build --cache-from ${BUILD_STAGE_IMAGE} -t $BUILD_STAGE_IMAGE -t $DOCKER_REGISTRY/$BUILD_CACHE:$CI_PIPELINE_IID .
    - docker push $DOCKER_REGISTRY/$BUILD_CACHE --all-tags
    # FINAL STAGE
    - docker pull ${FINAL_IMAGE} || true
    - docker build --target final --cache-from ${BUILD_STAGE_IMAGE} --cache-from ${FINAL_IMAGE} -t $FINAL_IMAGE -t $DOCKER_REGISTRY/$APP_NAME:$CI_PIPELINE_IID .
    - docker push $DOCKER_REGISTRY/$APP_NAME --all-tags
 

